/*
 *	app.h
 *
 *	ZKVXe1vC[
 *
 *	* Mon Mar 30 19:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <clip.h>

#define Z80_CLOCK	4000000
#define DCSG_CLOCK	2000000
#define IRQ_INTERVAL	(Z80_CLOCK / 240)

#define MAX_TRACK	64

typedef struct _DRIVER {
	/*{{CAEgŒ*/
	Z80 z80;
	unsigned char mem[0x10000];
	/*}}CAEgŒ*/
	SN76489 sn[2];
	//
	int track[MAX_TRACK];
	int num_track;
	//
	int int_progress;
} DRIVER;
extern DRIVER g_driver;

typedef struct _ROMSET {
	int year;				/* N */
	const char* name;			/* Q[ */
	const char* file;			/* ROMZbgt@C (NULL:Ή) */
	const ROM* program_roms;		/* vOROM */
	int num_program_roms;			/* vOROM */
	int track[MAX_TRACK];			/* egbÑR}hԍ */
	void (*init)(DRIVER* driver);		/* [` */
	void (*play)(DRIVER* driver, int reqno);/* tJn[` */
} ROMSET;

/* main.c */
int file_sel(DRIVER* driver, int i_file);
void track_sel(DRIVER* driver, const ROMSET* romset);
void driver_play(DRIVER* driver, const ROMSET* romset, int reqno);
int stream_callback(short wbuff[], int param);

/* fram.c */
void z80_write(Z80* z80, unsigned short addr, unsigned char data);
void driver_mix(DRIVER* driver, short wbuff[/*320*/]);
void sn76489_mix2(SN76489 sn[/*2*/], short wbuff[/*count*/], int count);
