/*
 *	fram.c
 *
 *	ZKVXe1vC[
 *
 *	* Mon Mar 30 19:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

void
z80_write(Z80* z80, unsigned short addr, unsigned char data)
{
	DRIVER* driver = (DRIVER*)z80;
	unsigned char* mem = driver->mem;

	if(addr < 0xa000) {
		mem[addr] = data;
	} else if(addr < 0xc000) {
		sn76489_write(&driver->sn[0], data);
	} else {
		sn76489_write(&driver->sn[1], data);
	}
}

void
driver_mix(DRIVER* driver, short wbuff[/*320*/])
{
	Z80* z80 = &driver->z80;

	int cnt1 = 320;	/* cTv */
	int cnt2;

	ASSERT(Z80_CLOCK >= SPEAKER_FREQUENCY);
	do {
		/* 񊄂荞ݔ܂ł̎cTCNŁATv~LVOł邩? */
		cnt2 = (driver->int_progress * SPEAKER_FREQUENCY + Z80_CLOCK - 1) / Z80_CLOCK;
		if(cnt2 > cnt1) cnt2 = cnt1;

		/* ~LVOB */
		sn76489_mix2(driver->sn, wbuff, cnt2);
		wbuff += cnt2;
		cnt1 -= cnt2;

		/* 񊄂荞ݔ܂ł̎cTCN炵āA0ɂȂ犄荞ݏB */
		driver->int_progress -= cnt2 * Z80_CLOCK / SPEAKER_FREQUENCY;
		while(driver->int_progress <= 0) {
			driver->int_progress += IRQ_INTERVAL;
			z80_int(z80, 0);
			z80_run(z80, Z80_CLOCK);
		}
	} while(cnt1);
}

void
sn76489_mix2(SN76489 sn[/*2*/], short wbuff[/*count*/], int count)
{
	DDA progress;
	int cycle;
	int sample;

	progress = sn->progress; /* ̂߁Aꎞo */
	while(count > 0) {
		/* o߃TCN߂܂B */
		cycle = progress.u;
		progress.d += progress.n;
		if(progress.d >= 0) {
			progress.d -= SPEAKER_FREQUENCY;
			cycle++;
		}

		/* 1Tv~LVO܂B */
		sample = sn76489_process(&sn[0], cycle)
		       + sn76489_process(&sn[1], cycle);

		/* NbsOĊi[܂B */
		if(sample < -0x7fff) sample = -0x7fff;
		if(sample >  0x7fff) sample =  0x7fff;
		*wbuff++ = sample;

		/* cTv炵܂B */
		count--;
	}
	sn->progress = progress; /* ߂BYꂸȂ!! */
}
