/*
 *	main.c
 *
 *	ZKVXe1vC[
 *
 *	* Mon Mar 30 19:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
//#define QUICK_REPEAT_DELAY	SEC(0.25)
#define QUICK_REPEAT_DELAY	SEC(0.5)

/* XvCg`BKvɉăCN[hĂBsprite.h̕ҏWKvłB */
//#include "sprite.h"
//#define DEFINE_SPRITE
//#include "sprite.h"
//#undef  DEFINE_SPRITE

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		10			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

//extern const unsigned char PAT[];
//extern const unsigned char BG[];
//TEXTURE pat;
//TEXTURE bg;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void run();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	//turbo(1); /* S48MHz[h */
	turbo(7); /* 48MHz/1WAIT */
	srand(pceTimerGetCount());
	/* rbg}bvB */
	//texture_init(&pat, PAT);
	//texture_init(&bg, BG);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		//if(joy & TRG_START) {
		if(0) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	
 ****************************************************************************/

DRIVER g_driver;

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	X^[WbJ[
 ****************************************************************************/

const ROM starjack_program_roms[] = {
	{ "epr-5332.3", 0x0000, 0x2000, 0x7a72ab3d },
};
void starjack_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x0097+0] = 0x76;	//HALT
	mem[0x0097+1] = 0x00;	//NOP
}
void starjack_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x048b] = 0x3a;	//LD A,(...)

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x048b] = 0xc9;	//RET
}
const ROMSET starjack_romset = {
	1983,
	"X^[WbJ[",
	"starjack.zip",
	starjack_program_roms,
	sizeof starjack_program_roms / sizeof(ROM),
	{0x82,0x84,0x85,0x86,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x90,0x93,0x94,0x95,-1},
	starjack_init,
	starjack_play,
};

/****************************************************************************
 *	4-DEH[A[Y
 ****************************************************************************/

const ROM _4dwarrio_program_roms[] = {
	{ "4d.120", 0x0000, 0x2000, 0x5241c009 },
};
void _4dwarrio_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x008a+0] = 0x76;	//HALT
	mem[0x008a+1] = 0x00;	//NOP
}
void _4dwarrio_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x04bf] = 0x3a;	//LD A,(...)

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x04bf] = 0xc9;	//RET
}
const ROMSET _4dwarrio_romset = {
	1985,
	"4-DEH[A[Y",
	"4dwarrio.zip",
	_4dwarrio_program_roms,
	sizeof _4dwarrio_program_roms / sizeof(ROM),
	{0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0xa0,0xa1,/*0xa2,*/0xa3,0xa4,0xa5,0xa6,/*0xa7,0xa8,*/-1},
	_4dwarrio_init,
	_4dwarrio_play,
};

/****************************************************************************
 *	~X^[oCLO
 ****************************************************************************/

const ROM mrviking_program_roms[] = {
	{ "epr-5763.3", 0x0000, 0x2000, 0xd712280d },
};
void mrviking_init(DRIVER* driver) {
	/** nothing to do (XHALTgĂ܂) **/
}
void mrviking_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x04f7] = 0x3a;	//LD A,(...)

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);
	z80_int(z80, 0);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);
	z80_int(z80, 0);
	z80_run(z80, Z80_CLOCK);

	mem[0x04f7] = 0xc9;	//RET
}
const ROMSET mrviking_romset = {
	1984,
	"~X^[oCLO",
	"mrviking.zip",
	mrviking_program_roms,
	sizeof mrviking_program_roms / sizeof(ROM),
	{0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,/*0x8b,*/0x8c,0x8d,0x8e,0x8f,0x90,/*0x91,*/0x92,0x93,0x94,0x95,-1},
	mrviking_init,
	mrviking_play,
};

/****************************************************************************
 *	tbL[
 ****************************************************************************/

const ROM flicky_program_roms[] = {
	{ "epr-5869.120", 0x0000, 0x2000, 0x6d220d4e },
};
void flicky_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x00a8+0] = 0x76;	//HALT
	mem[0x00a8+1] = 0x00;	//NOP
}
void flicky_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x04b3] = 0x06;	//LD B,...

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x04b3] = 0xc9;	//RET
}
const ROMSET flicky_romset = {
	1984,
	"tbL[",
	"flicky.zip",
	flicky_program_roms,
	sizeof flicky_program_roms / sizeof(ROM),
	{0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,/*0x8c,0x8d,*/0x8e,0x8f,0x90,0x91,/*0x92,*/0x93,-1},
	flicky_init,
	flicky_play,
};

/****************************************************************************
 *	wr[^
 ****************************************************************************/

const ROM hvymetal_program_roms[] = {
	{ "epr6787.120", 0x0000, 0x8000, 0xb64ac7f0 },
};
void hvymetal_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x011c+0] = 0x76;	//HALT
	mem[0x011c+1] = 0x00;	//NOP
}
void hvymetal_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x0673] = 0x3a;	//LD A,(...)

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x0673] = 0xc9;	//RET
}
const ROMSET hvymetal_romset = {
	1985,
	"wr[^",
	"hvymetal.zip",
	hvymetal_program_roms,
	sizeof hvymetal_program_roms / sizeof(ROM),
	{0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,/*0x98,0x99,0x9a,*/0x9b,0x9c,0x9d,0x9e,0x9f,0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,-1},
	hvymetal_init,
	hvymetal_play,
};

/****************************************************************************
 *	tXL_
 ****************************************************************************/

const ROM myhero_program_roms[] = {
	{ "epr-69xx.120", 0x0000, 0x2000, 0x0039e1e9 },
};
void myhero_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x008a+0] = 0x76;	//HALT
	mem[0x008a+1] = 0x00;	//NOP
}
void myhero_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x049e] = 0x3a;	//LD A,(...)

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x049e] = 0xc9;	//RET
}
const ROMSET myhero_romset = {
	1985,
	"tXL_",
	"myhero.zip",
	myhero_program_roms,
	sizeof myhero_program_roms / sizeof(ROM),
	{0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0xa0,-1},
	myhero_init,
	myhero_play,
};

/****************************************************************************
 *	ef{CuX
 ****************************************************************************/

const ROM teddybb_program_roms[] = {
	{ "epr6748x.120", 0x0000, 0x2000, 0xc2a1b89d },
};
void teddybb_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x0092+0] = 0x76;	//HALT
	mem[0x0092+1] = 0x00;	//NOP
}
void teddybb_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;


	mem[0x049f] = 0x21;	//LD HL,...

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x049f] = 0xc9;	//RET
}
const ROMSET teddybb_romset = {
	1985,
	"ef{CuX",
	"teddybb.zip",
	teddybb_program_roms,
	sizeof teddybb_program_roms / sizeof(ROM),
	{0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,/*0xb9,*/-1},
	teddybb_init,
	teddybb_play,
};

/****************************************************************************
 *	E҃vZX
 ****************************************************************************/

const ROM seganinj_program_roms[] = {
	{ "epr-6559.120", 0x0000, 0x2000, 0x5a1570ee },
};
void seganinj_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x0119+0] = 0x76;	//HALT
	mem[0x0119+1] = 0x00;	//NOP
}
void seganinj_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x0561] = 0x3a;	//LD A,(...)

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x0561] = 0xc9;	//RET
}
const ROMSET seganinj_romset = {
	1985,
	"E҃vZX",
	"seganinj.zip",
	seganinj_program_roms,
	sizeof seganinj_program_roms / sizeof(ROM),
	{0x81,0x82,0x83,0x84,0x85,0x87,/*0x89,0x8a,*/0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,/*0x93,*/0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,/*0x86,0x88,0x9f,*/0xa0,0xa1,0xa2,-1},
	seganinj_init,
	seganinj_play,
};

/****************************************************************************
 *	`bvt^[
 ****************************************************************************/

const ROM chplft_program_roms[] = {
	{ "epr-7130.126", 0x0000, 0x8000, 0x346af118 },
};
void chplft_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x011c+0] = 0x76;	//HALT
	mem[0x011c+1] = 0x00;	//NOP
}
void chplft_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0x0205] = 0x3a;	//LD A,(...)

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	mem[0x0205] = 0xc9;	//RET
}
const ROMSET chplft_romset = {
	1985,
	"`bvt^[",
	"chplft.zip",
	chplft_program_roms,
	sizeof chplft_program_roms / sizeof(ROM),
	{0x81,0x82,/*0x83,*/0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,-1},
	chplft_init,
	chplft_play,
};

/****************************************************************************
 *	UE
 ****************************************************************************/

const ROM bullfgt_program_roms[] = {
	{ "epr-6077.120", 0x0000, 0x2000, 0x02a37602 },
};
void bullfgt_init(DRIVER* driver) {
	unsigned char* mem = driver->mem;

	/* IRQtOĎ[vHALTB */
	mem[0x009c+0] = 0x76;	//HALT
	mem[0x009c+1] = 0x18;	//JR 0x009b
	mem[0x009c+2] = -4;
}
void bullfgt_play(DRIVER* driver, int reqno) {
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;

	mem[0xe000] = 0x00; /* S~R}h(?) */
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);

	/* NGXgԍi[B */
	mem[0xe000] = reqno;
	z80_nmi(z80);
	z80_run(z80, Z80_CLOCK);
}
const ROMSET bullfgt_romset = {
	1985,
	"UE",
	"bullfgt.zip",
	bullfgt_program_roms,
	sizeof bullfgt_program_roms / sizeof(ROM),
	{0x01,0x02,0x03,0x04,0x05,0x06,/*0x07,*/0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,/*0x1c,*/0x1d,0x1e,0x1f,0x20,0x21,0x22,-1},
	bullfgt_init,
	bullfgt_play,
};

/****************************************************************************
 *	
 ****************************************************************************/

const ROMSET* romset_list[] = {
	&starjack_romset,
	&flicky_romset,
	&mrviking_romset,
	&bullfgt_romset,
	&myhero_romset,
	&teddybb_romset,
	&seganinj_romset,
	&chplft_romset,
	&hvymetal_romset,
	&_4dwarrio_romset,
};
#define ROMSET_COUNT	(sizeof romset_list / sizeof *romset_list)

/****************************************************************************
 *	run
 ****************************************************************************/

#define MAX_DISP	7

void
run()
{
	DRIVER* driver = &g_driver;
	Z80* z80 = &driver->z80;
	unsigned char* mem = driver->mem;
	SN76489* sn = driver->sn;
	//
	int retval, i, i_file;
	const ROMSET* romset;

	i_file = 0;
	for(;;) {
		/* t@CIB */
		i_file = file_sel(driver, i_file);
		romset = romset_list[i_file];

		/* ܂NAB */
		memset(driver, 0, sizeof(DRIVER));

		/* gbNƃR}hԍ擾B */
		do {
			if(romset->track[driver->num_track] == -1) break; /* -1:I[ */
			driver->track[driver->num_track] = romset->track[driver->num_track];
			driver->num_track++;
		} while(driver->num_track < MAX_TRACK);

		/* Kv!! */
		driver->int_progress = IRQ_INTERVAL;

		/* ROMǂݍ݁B */
		{
			/* rom_load()͓mmap()Ammap()͓defrag()gĂ܂B
			 * 2004/03/30݁Adefrag()͎sɃG[ԂÎŁA
			 * 炩߃t@C݂̑𒲂ׂĂ܂B
			 */
			FILE* fp = fopen(romset->file, "rb");
			if(fp) {
				fclose(fp);
			} else {
				goto FILE_NOT_FOUND;
			}
		}
		retval = rom_load(romset->file, romset->program_roms, romset->num_program_roms, mem);
		if(retval != 0) {
FILE_NOT_FOUND:
			/*        012345678901234567890123 */
			err_disp("ROM̧ٓǍݎsł");
			continue;
		}

		/* ʂ̏B */
		romset->init(driver);

		/* Z80ADCSGZbgB */
		z80_reset(z80, NULL, z80_write, NULL, NULL);
		sn76489_reset(&sn[0], DCSG_CLOCK);
		sn76489_reset(&sn[1], DCSG_CLOCK);

		/* [`̃G~[VsB */
		i = 0;
		while(!z80->halt) {
#define X_POS ((DISP_X - 10 * 12) / 2    )
#define Y_POS ((DISP_Y - 10 *  2) / 2 + 2)
			render_rectangle_fill(&render, 0, Y_POS, DISP_X, 10 * 2 + 2, 3);
			render_string(&render, X_POS, Y_POS +  1, "łB", 0x80, i & 3);
			render_string(&render, X_POS, Y_POS + 11, "΂炭҂B", 0x80, i & 3);
			i++;
			schedule();
			z80_run(z80, Z80_CLOCK / 20);
#undef Y_POS
		}

		/* gbNIB */
		track_sel(driver, romset);

		/* mɃXg[~OĐ~B */
		stream_stop();
	}
}

int
file_sel(DRIVER* driver, int cursel)
{
	int curtop = 0;
	int prevsel = -1; /* ͋` */
	int prevtop = -1; /* ͋` */
	//
	int c, i, j, x, y, w;
	const ROMSET* romset;
	const char* s;

	for(;;) {
		schedule();

		/* I? */
		if(joy & TRG_SELECT) exit(0);

		/* t@CIύX? */
		if(joy & TRG_UP && cursel > 0               ) cursel--;
		if(joy & TRG_DN && cursel < ROMSET_COUNT - 1) cursel++;
		if(joy & TRG_LF) { cursel -= MAX_DISP; if(cursel < 0               ) cursel = 0;                }
		if(joy & TRG_RI) { cursel += MAX_DISP; if(cursel > ROMSET_COUNT - 1) cursel = ROMSET_COUNT - 1; }
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĕ`? */
		if(cursel != prevsel || curtop != prevtop) {
			prevsel = cursel;
			prevtop = curtop;
			surface_clear(&surface, 0);

			/* ROMZbgXg\B */
			y = 12;
			for(i = 0; i < MAX_DISP + 1; i++) {
				j = curtop + i;
				if(j > ROMSET_COUNT - 1) break;
				romset = romset_list[j];
				if(j == cursel) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 10 + 1, 2);
					c = 0;
				} else {
					c = 2;
				}
				if(!romset->file) c = 1; /* Ή */
				render_printf(&render, 4, y, 0x80, c, "%-20s%4d", romset->name, romset->year);
				y += 10;
			}

			/* ^Cg\B */
			s = "SEGA System1 Player";
			w = strlen(s) * 5;
			x = (DISP_X - w) / 2;
			render_rectangle_fill(&render, 0, 0, DISP_X, 11, 3);
			render_line(&render, 0        , 4, x - 4 , 4, 0);
			render_line(&render, x + w + 4, 4, DISP_X, 4, 0);
			render_line(&render, 0        , 6, x - 4 , 6, 0);
			render_line(&render, x + w + 4, 6, DISP_X, 6, 0);
			render_string(&render, x, 1, s, 0x80, 0);
		}

		/* Im? */
		if(joy & TRG_A) {
			romset = romset_list[cursel];
			if(romset->file) break; /* Ή */
		}
	}

	return cursel;
}

void
track_sel(DRIVER* driver, const ROMSET* romset)
{
	int cursel = 0;
	int curtop = 0;
	int prevsel = -1; /* ͋` */
	int prevtop = -1; /* ͋` */
	int playing = -1;

	int c, i, j, x, y, w;
	const char* s;

	for(;;) {
		schedule();

		/* I? */
		if(joy & TRG_SELECT) exit(0);

		/* t@CIύX? */
		if(joy & TRG_UP && cursel > 0                    ) cursel--;
		if(joy & TRG_DN && cursel < driver->num_track - 1) cursel++;
		if(joy & TRG_LF) { cursel -= MAX_DISP; if(cursel < 0                    ) cursel = 0;                     }
		if(joy & TRG_RI) { cursel += MAX_DISP; if(cursel > driver->num_track - 1) cursel = driver->num_track - 1; }
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĕ`? */
		if(cursel != prevsel || curtop != prevtop) {
			prevsel = cursel;
			prevtop = curtop;
			surface_clear(&surface, 0);

			/* ROMZbgXg\B */
			y = 12;
			for(i = 0; i < MAX_DISP + 1; i++) {
				j = curtop + i;
				if(j > driver->num_track - 1) break;
				if(j == cursel) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 10 + 1, 2);
					c = 0;
				} else {
					c = 2;
				}
				if(j == playing) c++; /* t */
				render_printf(&render, 4, y, 0x80, c, "TRACK %2d : %02Xh", j + 1, driver->track[j]);
				y += 10;
			}

			/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
			/* ^Cg\B */
			s = romset->name;
			w = strlen(s) * 5;
			x = (DISP_X - w) / 2;
			render_rectangle_fill(&render, 0, 0, DISP_X, 11, 3);
			render_line(&render, 0        , 4, x - 4 , 4, 0);
			render_line(&render, x + w + 4, 4, DISP_X, 4, 0);
			render_line(&render, 0        , 6, x - 4 , 6, 0);
			render_line(&render, x + w + 4, 6, DISP_X, 6, 0);
			render_string(&render, x, 1, s, 0x80, 0);
		}

		/* tJn? */
		if(joy & TRG_A) {
			stream_stop();
			romset->play(driver, driver->track[cursel]);
			stream_play(320, stream_callback, (int)driver, 1/*FRAM2X^bNؑ*/);
			playing = cursel;
			prevsel = -1; /* ĕ` */
			prevtop = -1; /* ĕ` */
		}

		/* t~? */
		if(joy & TRG_B) {
			if(playing < 0) break;
			stream_stop();
			playing = -1;
		}
	}
}

int
stream_callback(short wbuff[/*320*/], int param)
{
	if(pcePadGetDirect() & PAD_B) return -1; /* dꍇ̃nOAbv΍ */
	driver_mix((DRIVER*)param, wbuff);
	return 0;
}

